Index: /branches/2.2/phpgwapi/inc/class.sessions.inc.php
===================================================================
--- /branches/2.2/phpgwapi/inc/class.sessions.inc.php	(revision 1464)
+++ /branches/2.2/phpgwapi/inc/class.sessions.inc.php	(revision 3018)
@@ -343,35 +343,5 @@
 			}
 
-			/* ExpressoLivre
-			   Necessário comentar para que o redirecionamento de uma sessão
-			   https para uma http funcionasse atrás de um proxy
-			*/
-
-			/*
-			if (@$GLOBALS['phpgw_info']['server']['sessions_checkip'])
-			{
-				if((PHP_OS != 'Windows') && (PHP_OS != 'WINNT') &&
-					(!$GLOBALS['phpgw_info']['user']['session_ip'] || $GLOBALS['phpgw_info']['user']['session_ip'] != $this->getuser_ip())
-				)
-				{
-					//echo "IP do cliente com https   ---->  ".$GLOBALS['phpgw_info']['user']['session_ip'];
-					//echo "<BR>IP do cliente com http ---->  ".$this->getuser_ip();
-					if(is_object($GLOBALS['phpgw']->log))
-					{
-						// This needs some better wording
-						$GLOBALS['phpgw']->log->message(array(
-							'text' => 'W-VerifySession, IP %1 doesn\'t match IP %2 in session table',
-							'p1'   => $this->getuser_ip(),
-							'p2'   => $GLOBALS['phpgw_info']['user']['session_ip'],
-							'line' => __LINE__,
-							'file' => __FILE__
-						));
-						$GLOBALS['phpgw']->log->commit();
-					}
-					return False;
-				}
-			}
-			*/
-
+			
 			$GLOBALS['phpgw']->acl->acl($this->account_id);
 			$GLOBALS['phpgw']->accounts->accounts($this->account_id);
@@ -408,24 +378,5 @@
 		function getuser_ip()
 		{
-		/*
-			if (getenv(HTTP_X_FORWARDED_FOR))
-			{
-			        if (getenv(HTTP_CLIENT_IP))
-	        		{
-					$ip=getenv(HTTP_CLIENT_IP);
-				}
-				else
-				{
-					$ip=getenv(HTTP_X_FORWARDED_FOR);
-				}
-				$ip_proxy=getenv(REMOTE_ADDR);
-			}
-			else
-			{
-				$ip=getenv(REMOTE_ADDR);
-			}
-			return $ip;
-		*/
-			return (isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR']);
+			return (isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR']."," : "").$_SERVER['REMOTE_ADDR']; 
 		}
 
Index: /branches/2.2/phpgwapi/inc/class.setup.inc.php
===================================================================
--- /branches/2.2/phpgwapi/inc/class.setup.inc.php	(revision 1322)
+++ /branches/2.2/phpgwapi/inc/class.setup.inc.php	(revision 3018)
@@ -863,6 +863,6 @@
 				}
 				/* Load up some configured values */
-				$this->db->query("SELECT config_name,config_value FROM phpgw_config "
-					. "WHERE config_name LIKE 'ldap%' OR config_name LIKE 'account_%' OR config_name LIKE '%encryption%'",__LINE__,__FILE__);
+				$this->db->query("SELECT config_name,config_value,config_app FROM phpgw_config " 
+					. "WHERE config_app = 'phpgwapi' AND (config_name LIKE 'ldap%' OR config_name LIKE 'account_%' OR config_name LIKE '%encryption%')",__LINE__,__FILE__); 
 				while($this->db->next_record())
 				{
Index: /branches/2.2/phpgwapi/inc/class.sessions_php4.inc.php
===================================================================
--- /branches/2.2/phpgwapi/inc/class.sessions_php4.inc.php	(revision 2)
+++ /branches/2.2/phpgwapi/inc/class.sessions_php4.inc.php	(revision 3018)
@@ -125,10 +125,8 @@
 			else
 			{
-				$sessions = $this->list_sessions(0,'','',True);
-				
-				if (isset($sessions[$sessionid]))
-				{
-					//echo "<p>session_php4::destroy($session_id): unlink('".$sessions[$sessionid]['php_session_file'].")</p>\n";
-					@unlink($sessions[$sessionid]['php_session_file']);
+				if(@opendir($path = ini_get('session.save_path'))){ 
+					$session_file = $path."/sess_".$sessionid; 
+					if (file_exists($session_file)) 
+						@unlink($session_file); 
 				}
 			}
@@ -199,6 +197,4 @@
 		function list_sessions($start,$order,$sort,$all_no_sort = False)
 		{
-			//echo "<p>session_php4::list_sessions($start,'$order','$sort',$all)</p>\n";
-			$session_cache = $this->appsession('php4_session_cache','phpgwapi');
 
 			$values = array();
@@ -211,50 +207,15 @@
 			while ($file = readdir($dir))
 			{
-				if (substr($file,0,5) != 'sess_')
+				if (substr($file,0,5) != 'sess_' || !is_readable($path. '/' . $file))
 				{
 					continue;
 				}
-				if (isset($session_cache[$file]))	// use copy from cache
-				{
-					$session = $session_cache[$file];
-
-					if ($session['session_flags'] == 'A' || !$session['session_id'] ||
-						$session['session_install_id'] != $GLOBALS['phpgw_info']['server']['install_id'])
-					{
-						continue;	// no anonymous sessions or other domains or installations
-					}
-					if (!$all_no_sort)	// we need the up-to-date data --> unset and reread it
-					{
-						unset($session_cache[$file]);
-					}
-				}
-				if (!isset($session_cache[$file]))	// not in cache, read and cache it
-				{
-					if (!is_readable($path. '/' . $file))
-					{
-						continue;	// happens if webserver runs multiple user-ids
-					}
-					$session = '';
-					if (($fd = fopen ($path . '/' . $file,'r')))
-					{
-						$session = ($size = filesize ($path . '/' . $file)) ? @fread ($fd, $size) : 0;
-						fclose ($fd);
-					}
-					if (substr($session,0,14) != 'phpgw_session|')
-					{
-						continue;
-					}
-					$session = unserialize(substr($session,14));
-					unset($session['phpgw_app_sessions']);	// not needed, saves memory
-					$session_cache[$file] = $session;
-				}
-				if($session['session_flags'] == 'A' || !$session['session_id'] ||
-					$session['session_install_id'] != $GLOBALS['phpgw_info']['server']['install_id'])
-				{
-					continue;	// no anonymous sessions or other domains or installations
-				}
-				//echo "file='$file'=<pre>"; print_r($session); echo "</pre>"; 
-
-				$session['php_session_file'] = $path . '/' . $file;
+				$session = ''; 
+				if (($fd = fopen ($path . '/' . $file,'r'))) 
+				{ 
+					$session = ($size = filesize ($path . '/' . $file)) ? @fread ($fd, $size) : 0; 
+					fclose ($fd); 
+				} 
+				$session = unserialize(substr($session,14)); 
 				$values[$session['session_id']] = $session;
 			}
@@ -280,5 +241,4 @@
 				reset($values);
 			}
-			$this->appsession('php4_session_cache','phpgwapi',$session_cache);
 
 			return $values;
Index: /branches/2.2/phpgwapi/inc/functions.inc.php
===================================================================
--- /branches/2.2/phpgwapi/inc/functions.inc.php	(revision 1463)
+++ /branches/2.2/phpgwapi/inc/functions.inc.php	(revision 3018)
@@ -29,12 +29,5 @@
 
 	error_reporting(error_reporting() & ~E_NOTICE);
-
-	if (!function_exists('version_compare'))//version_compare() is only available in PHP4.1+
-	{
-		echo 'eGroupWare requires PHP 4.1 or greater.<br>';
-		echo 'Please contact your System Administrator';
-		exit;
-	}
-
+	
 	include(PHPGW_API_INC.'/common_functions.inc.php');
 	
@@ -378,4 +371,15 @@
 		reset($GLOBALS['phpgw_info']['flags']);
 
+
+		if(!include(PHPGW_SERVER_ROOT . '/phpgwapi/themes/default.theme'))  
+		{  
+			/* Hope we don't get to this point.  Better then the user seeing a */  
+			/* complety back screen and not know whats going on                */  
+			echo '<body bgcolor="FFFFFF">';  
+			$GLOBALS['phpgw']->log->write(array('text'=>'F-Abort, No themes found'));  
+
+			exit;  
+		}  
+
 		/*************************************************************************\
 		* These lines load up the templates class                                 *
@@ -390,51 +394,4 @@
 		}
 
-		/*************************************************************************\
-		* These lines load up the themes                                          *
-		\*************************************************************************/
-		if (! $GLOBALS['phpgw_info']['user']['preferences']['common']['theme'])
-		{
-			if (@$GLOBALS['phpgw_info']['server']['template_set'] == 'user_choice')
-			{
-				$GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] = 'default';
-			}
-			else
-			{
-				$GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] = $GLOBALS['phpgw_info']['server']['template_set'];
-			}
-		}
-		if (@$GLOBALS['phpgw_info']['server']['force_theme'] == 'user_choice')
-		{
-			if (!isset($GLOBALS['phpgw_info']['user']['preferences']['common']['theme']))
-			{
-				$GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] = 'default';
-			}
-		}
-		else
-		{
-			if (isset($GLOBALS['phpgw_info']['server']['force_theme']))
-			{
-				$GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] = $GLOBALS['phpgw_info']['server']['force_theme'];
-			}
-		}
-
-		if(@file_exists(PHPGW_SERVER_ROOT . '/phpgwapi/themes/' . $GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] . '.theme'))
-		{
-			include(PHPGW_SERVER_ROOT . '/phpgwapi/themes/' . $GLOBALS['phpgw_info']['user']['preferences']['common']['theme'] . '.theme');
-		}
-		elseif(@file_exists(PHPGW_SERVER_ROOT . '/phpgwapi/themes/default.theme'))
-		{
-			include(PHPGW_SERVER_ROOT . '/phpgwapi/themes/default.theme');
-		}
-		else
-		{
-			/* Hope we don't get to this point.  Better then the user seeing a */
-			/* complety back screen and not know whats going on                */
-			echo '<body bgcolor="FFFFFF">';
-			$GLOBALS['phpgw']->log->write(array('text'=>'F-Abort, No themes found'));
-
-			exit;
-		}
-		unset($theme_to_load);
 
 		/*************************************************************************\
@@ -488,20 +445,3 @@
 		}
 
-		/*************************************************************************\
-		* Load the app include files if the exists                                *
-		\*************************************************************************/
-		/* Then the include file */
-		if (PHPGW_APP_INC != "" &&
-                   ! preg_match ("/phpgwapi/i", PHPGW_APP_INC) &&
-                   file_exists(PHPGW_APP_INC . '/functions.inc.php') &&
-                   !isset($_GET['menuaction']))
-		{
-			include(PHPGW_APP_INC . '/functions.inc.php');
-		}
-		if (!@$GLOBALS['phpgw_info']['flags']['noheader'] &&
-			!@$GLOBALS['phpgw_info']['flags']['noappheader'] &&
-			file_exists(PHPGW_APP_INC . '/header.inc.php') && !isset($_GET['menuaction']))
-		{
-			include(PHPGW_APP_INC . '/header.inc.php');
-		}
-	}
+	}
Index: /branches/2.2/phpgwapi/inc/class.common.inc.php
===================================================================
--- /branches/2.2/phpgwapi/inc/class.common.inc.php	(revision 1576)
+++ /branches/2.2/phpgwapi/inc/class.common.inc.php	(revision 3018)
@@ -1264,29 +1264,44 @@
 			$tpl->set_var('app_css', $app_css);
 
-			// search for app specific css file
-			if(@isset($GLOBALS['phpgw_info']['flags']['currentapp']))
-			{
-				$appname = $GLOBALS['phpgw_info']['flags']['currentapp'];
-
-				if(file_exists(PHPGW_SERVER_ROOT . SEP . $appname . SEP
-					. 'templates' . SEP . $GLOBALS['phpgw_info']['server']['template_set']
-					. SEP . 'app.css')
-				)
-				{
-					$tpl->set_var('css_file', '<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url']
-						. "/$appname/templates/".$GLOBALS['phpgw_info']['server']['template_set']
-						. "/app.css".'" type=text/css rel=StyleSheet>');
-				}
-				elseif(file_exists(PHPGW_SERVER_ROOT . SEP . $appname . SEP
-					. 'templates' . SEP . 'default'
-					. SEP . 'app.css')
-				)
-				{
-					$tpl->set_var('css_file', '<LINK href="'.$GLOBALS['phpgw_info']['server']['webserver_url']
-					."/$appname/templates/default/app.css".'" type=text/css rel=StyleSheet>');
-				}
-			}
-
-			return $tpl->subst('css');
+			// search for app specific css filie
+			if ( @ isset( $GLOBALS[ 'phpgw_info' ][ 'flags' ][ 'currentapp' ] ) ) 
+			{ 
+				$css = "/%s/templates/%s/%s.css"; 
+
+				global $path, $link, $template; 
+
+				$path = PHPGW_SERVER_ROOT . str_replace( '/', SEP, $css ); 
+
+				$link = '<LINK href="%s" type="text/css" rel="StyleSheet">'; 
+				$link = sprintf( $link, 
+					"{$GLOBALS[ 'phpgw_info' ][ 'server' ][ 'webserver_url' ]}{$css}" 
+				); 
+
+				$template = $GLOBALS[ 'phpgw_info' ][ 'server' ][ 'template_set' ]; 
+
+				function _css( $module, $css ) 
+				{ 
+					global $link, $path, $template; 
+
+					if ( file_exists( sprintf( $path, $module, $template, str_replace( '/', SEP, $css ) ) ) ) 
+						return sprintf( $link, $module, $template, $css ); 
+
+					if ( file_exists( sprintf( $path, $module, 'default', str_replace( '/', SEP, $css ) ) ) ) 
+						return sprintf( $link, $module, 'default', $css ); 
+
+					return ''; 
+				} 
+
+				$css = _css( 'phpgwapi', 'css/base' ); 
+				$css .= _css( 'phpgwapi', "css/{$GLOBALS[ 'phpgw_info' ][ 'user' ][ 'preferences' ][ 'common' ][ 'theme' ]}" ); 
+				$css .= _css( $GLOBALS[ 'phpgw_info' ][ 'flags' ][ 'currentapp' ], "css/{$GLOBALS[ 'phpgw_info' ][ 'user' ][ 'preferences' ][ 'common' ][ 'theme' ]}" ); 
+				$css .= _css( $GLOBALS[ 'phpgw_info' ][ 'flags' ][ 'currentapp' ], 'app' ); 
+
+				if ( $css ) 
+					$tpl -> set_var( 'css_file', $css ); 
+			} 
+
+			return $tpl -> subst('css'); 
+
 		}
 
Index: /branches/2.2/expressoAdmin1_2/inc/class.manager.inc.php
===================================================================
--- /branches/2.2/expressoAdmin1_2/inc/class.manager.inc.php	(revision 1913)
+++ /branches/2.2/expressoAdmin1_2/inc/class.manager.inc.php	(revision 3018)
@@ -1,3 +1,3 @@
-<?
+<?php
 	/***********************************************************************************\
 	* Expresso Administração                 										   *
Index: /branches/2.2/expressoAdmin1_2/js/jscode/connector.js
===================================================================
--- /branches/2.2/expressoAdmin1_2/js/jscode/connector.js	(revision 317)
+++ /branches/2.2/expressoAdmin1_2/js/jscode/connector.js	(revision 3018)
@@ -499,5 +499,5 @@
 			 
 		id = url;
-		connector.newRequest(id, url, method, handler, params);
+		admin_connector.newRequest(id, url, method, handler, params);
 	}
 	
@@ -508,9 +508,9 @@
 	//	form: form element (for upload files)	
 	function cExecuteForm(url, form, handler){
-		connector.buildBar();
+		admin_connector.buildBar();
 		isExecuteForm = true;		
 		document.onmouseup = alertBut;
 		
-		connector.showProgressBar();
+		admin_connector.showProgressBar();
 		if(! (divUpload = document.getElementById('divUpload'))) {
 			divUpload		= document.createElement('DIV');		
@@ -554,8 +554,8 @@
 		if(isExecuteForm) {
 	    	if(confirm("There's an action processing. Do you want abort it?")) {
-		    	connector.hideProgressBar();
+		    	admin_connector.hideProgressBar();
 		    	isExecuteForm = false;
-		    	delete connector.requests[id];								
-				connector.requests[id] = null;
+		    	delete admin_connector.requests[id];								
+				admin_connector.requests[id] = null;
 	    		stop();		    		    		
 	    		return;
Index: /branches/2.2/expressoAdmin1_2/js/jscode/users.js
===================================================================
--- /branches/2.2/expressoAdmin1_2/js/jscode/users.js	(revision 1913)
+++ /branches/2.2/expressoAdmin1_2/js/jscode/users.js	(revision 3018)
@@ -139,5 +139,5 @@
 	if (document.forms[0].mailalternateaddress.value != '')
 		attrs_array['mailalternateaddress'] = document.forms[0].mailalternateaddress.value;
-	var attributes = connector.serialize(attrs_array);
+	var attributes = admin_connector.serialize(attrs_array);
 
 	var handler_validate_fields = function(data)
@@ -156,4 +156,6 @@
 			if (type == 'create_user')
 			{
+				// Turn enabled checkbox on create user. 
+                                document.getElementById('changepassword').disabled = false; 
 				cExecuteForm ("$this.user.create", document.forms[0], handler_create);
 			}
@@ -203,5 +205,5 @@
 	attrs_array['first_name'] = first_name;
 	attrs_array['second_name'] = second_name;
-	var attributes = connector.serialize(attrs_array);
+	var attributes = admin_connector.serialize(attrs_array);
 	
 	var handler_generate_login = function(data) {
@@ -539,5 +541,5 @@
 		attrs_array['type'] = 'rename_user';
 		attrs_array['uid'] = new_uid;
-		attributes = connector.serialize(attrs_array);
+		attributes = admin_connector.serialize(attrs_array);
 	
 		cExecute ('$this.ldap_functions.validate_fields&attributes='+attributes, handler_validate_fields);
Index: /branches/2.2/admin/inc/class.uiconfig.inc.php
===================================================================
--- /branches/2.2/admin/inc/class.uiconfig.inc.php	(revision 1325)
+++ /branches/2.2/admin/inc/class.uiconfig.inc.php	(revision 3018)
@@ -200,4 +200,5 @@
 			$t->set_var('row_on',    $GLOBALS['phpgw_info']['theme']['row_on']);
 			$t->set_var('row_off',   $GLOBALS['phpgw_info']['theme']['row_off']);
+			$t->set_var('php_upload_limit',str_replace('M','',ini_get('upload_max_filesize')));
 			$t->pparse('out','header');
 
Index: /branches/2.2/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- /branches/2.2/contactcenter/inc/class.ui_data.inc.php	(revision 1690)
+++ /branches/2.2/contactcenter/inc/class.ui_data.inc.php	(revision 3018)
@@ -2072,5 +2072,5 @@
 
 			/* Verify Data and performs insertion/update */
-			foreach($data as $field => &$value)
+			foreach($data as $field => $value)
 			{
 				if ($value == '' or is_null($value))
@@ -2082,4 +2082,6 @@
 				switch($field)
 				{
+					case 'names_ordered':
+						$data[$field] = urldecode($value); 
 					case 'corporate_name':
 					case 'job_title':
@@ -2089,8 +2091,7 @@
 					case 'given_names':
 					case 'family_names':
-					case 'names_ordered':
 					case 'pgp_key':
 					case 'notes':
-						/* Do Nothing. This is just to make sure no invalid field is passed */
+						$data[$field] = urldecode($data[$field]);
 						break;
 
@@ -2167,5 +2168,5 @@
 								if ($value['new_cities'][$type])
 								{
-									$value['new_cities'][$type]['id_state'] = $id_state;
+									$data[$field]['new_cities'][$type]['id_state'] = $id_state; 
 								}
 							}
@@ -2203,9 +2204,7 @@
 			}
 
-			$code = '$id = $this->bo->catalog->';
-
 			if (!is_null($id) and $id !== '')
 			{
-				$code .= $code.'update_single_info($id, $data);';
+				$id = $this->bo->catalog->update_single_info($id, $data); 
 				$result = array(
 					'msg' => lang('Updated Successfully!'),
@@ -2215,5 +2214,5 @@
 			else
 			{
-				$code .= 'add_single_entry($data);';
+				$id = $this->bo->catalog->add_single_entry($data); 
 				$result = array(
 					'msg' => lang('Entry Added Successfully!'),
@@ -2221,6 +2220,4 @@
 				);
 			}
-
-			eval($code);
 
 			if (!($id))
@@ -2371,6 +2368,5 @@
 					case 'notes':
 					case 'photo':
-						$value = urldecode( $value );
-						/* Do Nothing. This is just to make sure no invalid field is passed */
+						$data[$field] = urldecode( $value ); 
 						break;
 
Index: /branches/2.2/logout.php
===================================================================
--- /branches/2.2/logout.php	(revision 2)
+++ /branches/2.2/logout.php	(revision 3018)
@@ -20,5 +20,5 @@
 		'nonavbar'               => True
 	);
-	include('./header.inc.php');
+	include(dirname( __FILE__ ).'/header.inc.php');
 
 	$GLOBALS['sessionid'] = get_var('sessionid',array('GET','COOKIE'));
Index: /branches/2.2/preferences/preferences.php
===================================================================
--- /branches/2.2/preferences/preferences.php	(revision 1933)
+++ /branches/2.2/preferences/preferences.php	(revision 3018)
@@ -487,5 +487,5 @@
 		if (!is_admin() || $error)
 		{
-			$GLOBALS['phpgw']->redirect_link('/preferences/index.php');
+			$GLOBALS['phpgw']->redirect_link('/'.$_GET['appname'].'/'); 
 		}
 		
Index: /branches/2.2/security/captcha.php
===================================================================
--- /branches/2.2/security/captcha.php	(revision 1574)
+++ /branches/2.2/security/captcha.php	(revision 3018)
@@ -111,4 +111,6 @@
   $GLOBALS['captcha'] = new captcha;
   // Guarda o string do captcha na session...
+  session_id($_REQUEST['xsid']); 
+  session_start(); 
   $_SESSION['CAPTCHAString'] = $GLOBALS['captcha'] ->GetCaptchaString();
   // Vai exibir a imagem do captcha...
Index: /branches/2.2/header.session.inc.php
===================================================================
--- /branches/2.2/header.session.inc.php	(revision 1464)
+++ /branches/2.2/header.session.inc.php	(revision 3018)
@@ -1,16 +1,57 @@
 <?php
-	session_id( $_COOKIE[ 'sessionid' ] );
-	session_start( );
+if ( isset( $_COOKIE[ 'sessionid' ] ) ) 
+	session_id( $_COOKIE[ 'sessionid' ] ); 
 
-	$sess = $_SESSION[ 'phpgw_session' ];
-        $connection_id = "{$sess['session_id']}{$sess['session_ip']}".substr($_SERVER[ 'HTTP_USER_AGENT' ],0,199);
+session_start( );
 
+$sess = $_SESSION[ 'phpgw_session' ];
+$invalidSession = false; 
+$user_agent = array(); 
+if (isset($GLOBALS['phpgw']) && !isset($_SESSION['connection_db_info'])){ 
+	$_SESSION['phpgw_info']['admin']['server']['sessions_checkip'] = $GLOBALS['phpgw_info']['server']['sessions_checkip'];
+	if($GLOBALS['phpgw_info']['server']['use_https'] == 1) { 
+		$new_ip = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR']."," : ""). $_SERVER['REMOTE_ADDR']; 
+		$GLOBALS['phpgw']->db->query("UPDATE phpgw_access_log SET ip='$new_ip' WHERE account_id <> 0 and lo = 0 and sessionid='{$GLOBALS['sessionid']}'",__LINE__,__FILE__); 
+	} 
+	 $GLOBALS['phpgw']->db->query("select trim(sessionid),".($_SESSION['phpgw_info']['admin']['server']['sessions_checkip'] ? "ip," : "")."browser from phpgw_access_log where account_id <> 0 and lo = 0 and sessionid='{$GLOBALS['sessionid']}' limit 1",__LINE__,__FILE__); 
+	$GLOBALS['phpgw']->db->next_record(); 
+	if($GLOBALS['phpgw']->db->row( )) 
+		$_SESSION['connection_db_info']['user_auth'] = implode("",$GLOBALS['phpgw']->db->row( )); 
+} 
+if($_SESSION['connection_db_info']['user_auth']){ 
+	$invalidSession = true; 
+	$http_user_agent = substr($_SERVER[ 'HTTP_USER_AGENT' ],0,199); 
+	$user_ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? array($_SERVER['REMOTE_ADDR'], $_SERVER['HTTP_X_FORWARDED_FOR']) : array($_SERVER['REMOTE_ADDR']); 
+	$user_agent[] = ($_SESSION['phpgw_info']['admin']['server']['sessions_checkip'] ? "{$sess['session_id']}{$user_ip[0]}" : "{$sess['session_id']}").$http_user_agent;
+	if(count($user_ip) == 2) { 
+		$user_agent[] = "{$sess['session_id']}{$user_ip[1]}".$http_user_agent; 
+		$user_agent[] = $sess['session_id'].implode(",",array_reverse($user_ip)).$http_user_agent; 
+	} 
+	$pconnection_id = $_SESSION['connection_db_info']['user_auth']; 
+	if(array_search($pconnection_id, $user_agent)  !== FALSE) { 
+		$invalidSession = false; 
+	} 
+} 
+if (empty($_SESSION['phpgw_session']['session_id']) || $invalidSession) 
+{
+	if($_SESSION['connection_db_info']['user_auth'] && !strstr($_SERVER['SCRIPT_URL'],"/controller.php")) {
+		error_log( '[ INVALID SESSION ] >>>>' .$_SESSION['connection_db_info']['user_auth'].'<<<< - >>>>' . implode("",$user_agent), 0 ); 
+		$GLOBALS['phpgw']->session->phpgw_setcookie('sessionid'); 
+		$GLOBALS['phpgw']->redirect($GLOBALS['phpgw_info']['server']['webserver_url'].'/login.php?cd=10'); 
+	} 
 
-	if ($_SESSION['connection_db_info']['user_auth'] && implode('',$_SESSION['connection_db_info']['user_auth']) !== $connection_id)
-	{
-		setcookie("PHPSESSID","",0);
-		setcookie ("sessionid","",0);
-		echo lang("An important error has occured with your login, please contact your system administrator");	
-		exit;
-	}
+	setcookie(session_name(),"",0); // Removing session cookie. 
+	unset($_SESSION);                               // Removing session values. 
+	// From ExpressoAjax response "nosession" 
+	if(strstr($_SERVER['SCRIPT_URL'],"/controller.php")){ 
+		echo serialize(array("nosession" => true)); 
+		exit; 
+	} 
+} 
+else{ 
+	// From ExpressoAjax update session_dla (datetime last access).  
+	if(strstr($_SERVER['SCRIPT_URL'],"/controller.php")) 
+		$_SESSION['phpgw_session']['session_dla'] = time(); 
+
+}
 ?>
Index: /branches/2.2/calendar/inc/class.boicalendar.inc.php
===================================================================
--- /branches/2.2/calendar/inc/class.boicalendar.inc.php	(revision 678)
+++ /branches/2.2/calendar/inc/class.boicalendar.inc.php	(revision 3018)
@@ -1275,5 +1275,6 @@
 			if($this->line < count($ical_text))
 			{
-				$str = str_replace("\r\n",'',$ical_text[$this->line]);
+				$str = str_replace(array("\r\n","\r","\n"), '', $ical_text[$this->line]);
+
 				$this->line = $this->line + 1;
 				while(ereg("^[[:space:]]",$ical_text[$this->line]))
@@ -1282,4 +1283,6 @@
 					$this->line = $this->line + 1;
 				}
+				// Corrige a codificacao dos caracteres
+				$str = utf8_decode ( trim ($str) );
 				$this->debug("LINE : ".$str);
 				return $str;
@@ -1405,4 +1408,5 @@
 		function parse_parameters(&$event,$majortype,$value)
 		{
+			$this->debug ('value: '.$value);
 			if(!ereg('[\=\;]',$value))
 			{
@@ -1451,4 +1455,6 @@
 				}
 			}
+
+			$this->debug('parse_parameters array return_value: '._debug_array($return_value,False));
 
 			for($i=0;$i<count($return_value);$i++)
@@ -1528,5 +1534,5 @@
 			if($this->property[$majortype][$mode]['multiples'])
 			{
-				$this->debug(_debug_array($var,False));
+				$this->debug('parse_value var array: '._debug_array($var,False));
 				$event[$majortype][] = $var;
 			}
@@ -1540,10 +1546,13 @@
 					$t_var = $var[$majortype];
 					unset($var[$majortype]);
-					reset($t_var);
-					while(list($key,$val) = each($t_var))
-					{
-						$var[$key] = $val;
-					}
-					$this->debug($majortype.' : '._debug_array($var,False));
+					if ( $t_var )
+					{
+						reset($t_var);
+						while(list($key,$val) = each($t_var))
+						{
+							$var[$key] = $val;
+						}
+						$this->debug($majortype.' : '._debug_array($var,False));
+					}
 				}
 				$this->set_var($event,$majortype,$var);
@@ -2260,7 +2269,5 @@
 		function switch_partstat($var)
 		{
-//			$this->debug_str = True;
 			$this->debug('PARTSTAT = '.$var);
-//			$this->debug_str = False;
 			if(is_string($var))
 			{
@@ -2567,4 +2574,5 @@
 
 				ereg($property_regexp,$text,$temp);
+				$this->debug ('Majortype dump: '._debug_array($temp, false) );
 				$majortype = str_replace('-','_',strtolower($temp[1]));
 				$value = chop($temp[2]);
@@ -2767,5 +2775,5 @@
 				elseif($state == 'optional' || $state == 'required')
 				{
-					$this->debug('Mode : '.$mode.' Majortype : '.$majortype);
+					$this->debug('Mode : '.$mode.' Majortype : '.$majortype . ' Type : '.$type);
 					if($do_to_text)
 					{
@@ -3016,4 +3024,5 @@
 					break;
 			}
+			$this->debug ('ical parse result: ' . _debug_array ($ical, false));
 			$c_events = count($ical['event']);
 			for($i=0;$i<$c_events;$i++)
@@ -3056,4 +3065,24 @@
 						$so_event->set_ex_participants($ical['event'][$i]['ex_participants']['value']);
 					}
+					// Compatibilidade com agendamentos vindos do outlook/exchange
+					if ( isset ($ical['event'][$i]['attendee']) )
+					{
+						$c_attendees = count($ical['event'][$i]['attendee']);
+						$all_attendees = '';
+						for ( $a=0; $a < $c_attendees; $a++ )
+						{
+							$cname = '"'. $ical['event'][$i]['attendee'][$a]['cn'] .'"';
+							$email = $ical['event'][$i]['attendee'][$a]['mailto']['user'];
+							if ( $email )
+								$email = '<'. $email .'@'. $ical['event'][$i]['attendee'][$a]['mailto']['host'] .'>';
+							else
+								$email = '';
+							
+							$all_attendees .= $cname . $email .', ';
+						}
+						$this->debug ('All attendees: ' . $all_attendees);
+						$so_event->set_ex_participants($all_attendees);
+					}
+
 					if($ical['event'][$i]['location']['value'])
 					{
@@ -3296,5 +3325,5 @@
 					else
 					{
-//owner
+						$so_event->add_attribute('participants','A',(int)$GLOBALS['phpgw_info']['user']['account_id']);
 					}
 
@@ -3585,5 +3614,8 @@
 			if($this->debug_str)
 			{
-				echo $str."<br>\n";
+				//echo $str."<br>\n";
+				$log = fopen('/tmp/calendar.log', 'a') or die("nao foi possivel abrir o arquivo /tmp/calendar.log");
+				fwrite($log, $str . "\n");
+				fclose($log);
 			}
 		}
Index: /branches/2.2/calendar/inc/class.socalendar_sql.inc.php
===================================================================
--- /branches/2.2/calendar/inc/class.socalendar_sql.inc.php	(revision 1949)
+++ /branches/2.2/calendar/inc/class.socalendar_sql.inc.php	(revision 3018)
@@ -309,4 +309,5 @@
 							);
 
+					$result = array(); 
 					do
 					{
@@ -317,5 +318,5 @@
 						if($quociente == 1)
 						{
-							$result[] .= $dias_semana[$divisor];
+							$result[] = $dias_semana[$divisor];
 
 							$divisor = $divisor / 2;
@@ -335,5 +336,5 @@
 							{
 
-								$result[] .= $dias_semana[$divisor];
+								$result[] = $dias_semana[$divisor];
 
 								$divisor = $divisor / 2;
Index: /branches/2.2/expressoMail1_2/index.php
===================================================================
--- /branches/2.2/expressoMail1_2/index.php	(revision 1735)
+++ /branches/2.2/expressoMail1_2/index.php	(revision 3018)
@@ -62,4 +62,5 @@
 	
 	$preferences = $GLOBALS['phpgw']->preferences->read();
+	$_SESSION['phpgw_info']['user']['preferences']['expressoMail'] = $preferences['enable_local_messages']; 
 	$_SESSION['phpgw_info']['user']['preferences']['expressoMail'] = $preferences['expressoMail'];
 	$_SESSION['phpgw_info']['user']['preferences']['expressoMail']['voip_enabled'] = $voip_enabled;
@@ -163,6 +164,7 @@
 	include("inc/load_lang.php"); 
 
-	// INCLUDE these JS Files: 
-	echo "<script src='js/gears_init.js'></script>";
+	// INCLUDE these JS Files:
+	if ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_local_messages']) 
+		echo "<script src='js/gears_init.js'></script>";
 	echo $obj -> getFilesJs("js/abas.js," .
 							"js/doiMenuData.js," .
Index: /branches/2.2/expressoMail1_2/inc/class.db_functions.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.db_functions.inc.php	(revision 1992)
+++ /branches/2.2/expressoMail1_2/inc/class.db_functions.inc.php	(revision 3018)
@@ -1,6 +1,17 @@
 <?php
-define('PHPGW_INCLUDE_ROOT','../');	
-define('PHPGW_API_INC','../phpgwapi/inc');	
-include_once(PHPGW_API_INC.'/class.db.inc.php');
+if(!isset($_SESSION['phpgw_info']['expressomail']['server']['db_name'])) { 
+	include_once('../header.inc.php'); 
+	$_SESSION['phpgw_info']['expressomail']['server']['db_name'] = $GLOBALS['phpgw_info']['server']['db_name'];  
+	$_SESSION['phpgw_info']['expressomail']['server']['db_host'] = $GLOBALS['phpgw_info']['server']['db_host']; 
+	$_SESSION['phpgw_info']['expressomail']['server']['db_port'] = $GLOBALS['phpgw_info']['server']['db_port']; 
+	$_SESSION['phpgw_info']['expressomail']['server']['db_user'] = $GLOBALS['phpgw_info']['server']['db_user']; 
+	$_SESSION['phpgw_info']['expressomail']['server']['db_pass'] = $GLOBALS['phpgw_info']['server']['db_pass']; 
+	$_SESSION['phpgw_info']['expressomail']['server']['db_type'] = $GLOBALS['phpgw_info']['server']['db_type']; 
+} 
+else{ 
+	define('PHPGW_INCLUDE_ROOT','../');      
+	define('PHPGW_API_INC','../phpgwapi/inc');       
+	include_once(PHPGW_API_INC.'/class.db.inc.php'); 
+} 
 include_once('class.dynamic_contacts.inc.php');
 	
@@ -214,4 +225,6 @@
 		if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['number_of_contacts'] &&
 			$_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_dynamic_contacts']) {
+			// Free others requests 
+                        session_write_close(); 
 			$dynamic_contact = new dynamic_contacts();
 			$dynamic = $dynamic_contact->dynamic_contact_toString();
@@ -353,4 +366,6 @@
 				$calendar = $fileContent;
 		}
+		// It's necessary to access calendar method. 
+		include_once(PHPGW_INCLUDE_ROOT.'/header.inc.php'); 
 			
 		$uiicalendar = CreateObject("calendar.uiicalendar");
